#include <stdbool.h>
#include <stdarg.h>
#include <stdint.h>
#include <time.h>

extern void   HttpAddChar       (char c);
extern void   HttpFillChar      (char c, int length);
extern int    HttpAddText       (const char* text);
extern int    HttpAddV          (char *fmt, va_list argptr);
extern int    HttpAddF          (char *fmt, ...);
extern void   HttpAddData       (const char* data, int length);
extern void   HttpAddStream     (void (*startFunction)(void), int (*enumerateFunction)(void));
extern void   HttpAddNibbleAsHex(int value);
extern void   HttpAddByteAsHex  (int value);
extern void   HttpAddInt12AsHex (int value);
extern void   HttpAddInt16AsHex (int value);
extern void   HttpAddInt32AsHex (int value);
extern void   HttpAddInt64AsHex (int64_t value);
extern void   HttpAddTm         (struct tm* ptm);

extern int    HttpRequestRead  (char *p, int len, char** ppMethod, char** ppPath, char** ppQuery, char** ppLastModified, char** ppCookies, int* pContentLength);

extern char*  HttpCookiesSplit   (char* pCookies, char** ppName, char** ppValue);
extern char*  HttpQuerySplit     (char* pQuery,   char** ppName, char** ppValue);
extern int    HttpQueryValueAsInt(char* pValue);
extern void   HttpQueryUnencode  (char* pValue);

extern void (*HttpRequestFunction)(int size, char* pRequestStream, uint32_t positionInRequestStream, int* pToDo, bool* pPostComplete, uint32_t* pDelayUntil);
extern void (*HttpReplyFunction  )(int todo);

extern bool   HttpTrace;
extern void   HttpHandleRequest(int   size, char* pRequestStream, uint32_t positionInRequestStream, int* pToDo, bool* pPostComplete, uint32_t* pDelayUntil);
extern void   HttpSendReply    (int* pSize, char* pReplyStream,   uint32_t positionInReplyStream, uint16_t mss, int todo);

extern void   HttpDateFromDateTime(const char* date, const char *ptime, char* ptext);
extern void   HttpDateFromNow(char* pText);

extern bool HttpSameStr               (const char* pa,   const char* pb);
extern bool HttpSameStrCaseInsensitive(const char* pa,   const char* pb);
extern bool HttpSameDate              (const char* date, const char* time, const char* pOtherDate);

#define HTTP_DATE_LENGTH 30

